#include <stdio.h>
/*#include <time.h> 
#include <dos.h>
#include <stdlib.h>
*/
#include <math.h>
//-pac- #include <malloc.h>
#include <string.h>
/*#include <strings.h>*/
#define NSYM 4
#define ERR stdout
#define ACU  0.00000000001
typedef struct nodc {
   char childio[3];
   int childn[3];
 } Nodc;

/*  */
int tr[4][4]={-1,1,0,1,
                1,-1,1,0,
                0,1,-1,1,
                1,0,1,-1};
int tr1[4][4]={0,3,1,3,
               3,0,3,2,
               1,3,0,3,
               3,2,3,0};



int trp[5][5]={-1,0 ,0,0,0,
                0,-1,0,0,0,
                0,0,-1,0,0,
                0,0,0,-1,0,
                0,0,0,0,-1};

int dflg=0;

char base[9]={'A','T','G','C','-','*','X','?','N'};
char amn[24]={'A','C','D','E','F','G','H','I','K','L','M','N','P','Q',
                     'R','S','T','V','W','Y','-','?','*','X'};
/* tr specifies: no change -1, transition 0, transversion 1 */

int *ivector(n)
int n;
{
int *vp;

   vp = (int *)malloc((unsigned) n*sizeof(int));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"integer vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}
char *cvector(n)
int n;
{
char *vp;

   vp = (char *)malloc((unsigned) n*sizeof(char));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"char vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

double *dvector(n)
int n;
{
double *vp;

   vp = (double *)malloc((unsigned) n*sizeof(double));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"double vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

int **imatrix(n1,n2)
int n1,n2;
{
int i,**ip;

 ip = (int **) malloc((unsigned ) n1*sizeof(int*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 integer matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (int *) malloc((unsigned) n2*sizeof(int));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}




char **cmatrix(n1,n2)
int n1,n2;
{
int i;
char **ip;

 ip = (char **) malloc((unsigned ) n1*sizeof(char*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (char *) malloc((unsigned) n2*sizeof(char));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


double **dmatrix(n1,n2)
int n1,n2;
{
int i;
double **ip;

 ip = (double **) malloc((unsigned ) n1*sizeof(double*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (double *) malloc((unsigned) n2*sizeof(double));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) double matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


Nodc **nvector(n)
int n;
{
int i;
Nodc **ip;

 ip = (Nodc **) malloc((unsigned ) n*sizeof(Nodc*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"Nodc step1 %d\n",n);
    exit(1);
  }
 for(i=0; i<n ; i++){
   ip[i] = (Nodc *) malloc(sizeof(Nodc));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) Tnode %d\n",i,n);
    exit(1);

  }
 }
 
  return(ip);
				 
}


void free_ivector(v,n)
int *v,n;
{
   free((char*) v );
   return ;
 }

void free_dvector(v,n)
double *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cvector(v,n)
char *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cmatrix(m,n1,n2)
char **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}

void free_imatrix(m,n1,n2)
int  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_dmatrix(m,n1,n2)
double  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_nvector(ip,n)
Nodc **ip;
int n;
{
int i;


 for(i=n-1; i>=0 ; i--){
   free((char*) ip[i]);
 }
 free((char *)ip); 
  return ;
				 
}

checkfl(fpi,nseq,nsite,maxnm)
FILE *fpi;
int *nseq,*nsite,*maxnm;
{
int cw,flg,fc,sc,flg1,cw1;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */

   *nseq=0;
   *nsite =0;
   *maxnm=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  if( fc > *maxnm ) *maxnm=fc;
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                   if( *nseq == 0 ) {
                     *nsite = sc;
                   }else{
                     if( sc != *nsite ){
                        fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq)+1);
                        exit(1);                                                                    }
                   }
                   (*nseq)++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		 }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 sc++;
	}
     
    }
    if( sc != 0 ){
      if( sc != *nsite ){
            fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq)+1);
            exit(1);                                                                    }
      (*nseq)++;
    }
    return(0);
}

rdseq(fpi,nseq,nsite,seq,seqnm,maxnm)
FILE *fpi;
int nseq,nsite,maxnm;
char **seq,**seqnm;
{
int i,cw,flg,fc,sc,flg1,cw1,seqc,sitec,cn;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */
   cn=0;
   seqc=0;
   sitec=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      cn++;
      if( cn == 1 ) continue;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      

      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                seqnm[seqc][fc]=cw1;
                fc++;
                if( fc > maxnm ) printf("fc=%d maxnm=%d seq %d\n",fc,maxnm,seqc);
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                seqnm[seqc][fc]=cw1;
                fc++;
                if( fc > maxnm ) printf("fc=%d maxnm=%d seq %d\n",fc,maxnm,seqc);
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 seq[sc][seqc]=cw1;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                     if( sc != nsite ){
                        fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,(seqc)+1);
                        exit(1);                                                                    }
                   seqc++;
                   if( seqc > nseq ) printf("seqc=%d nseq=%d\n",seqc,nseq);
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		   }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 seq[sc][seqc]=cw1;
                 sc++;
                 break;
	default: break;
	}
     
    }
    if( sc != 0 ){
      if( sc != nsite ){
            fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,seqc+1);
            exit(1);                                                                    }
      seqc++;
    }
   if( seqc != nseq ){
      printf("sequence number inconsistency seqc=%d nseq=%d\n",seqc,nseq);
      exit(1);
    }
   

/*   printf("rdseq seqc=%d\n",seqc); */
/*   for(i=0; i<nseq ; i++) printf("%d %s\n",i+1,seqnm[i]); */

    return(0);
}

njt(nseq,dist,node,branch0,otu,spair,sw,st,dcm,rij)
int nseq,**node/*[MAXOTU-2][3]*/;
int *otu/*[MAXOTU]*/,**spair/*[MAXOTU*(MAXOTU-1)/2][2]*/,*sw/*[MAXOTU*(MAXOTU-1)/2]*/;
double *st/*[MAXOTU*(MAXOTU-1)/2]*/,*dcm/*[MAXOTU]*/,*rij/*[MAXOTU]*/;
double **dist/*[MAXOTU][MAXOTU]*/,**branch0/*[MAXOTU][3]*/;
{
int i,j,k,l,nsc,cyc,comb,scnt,n1,n2,n3,nsm,nsw,rn;
double dw,s1,s2,s3,s,sm,ri,rj,ds;
double s12,s34,s56,s78;
  nsc=nseq;
  
  for(i=0; i<nseq-2 ; i++){
    for(j=0; j<3 ; j++) node[i][j]=0;
  }
  for(i=0; i<nseq; i++) otu[i]=i+1;
  for(cyc=0; cyc<nseq-3; cyc++){
     scnt=0;
     ds=nsc-2;
     for(i=0; i<nsc ; i++){
        rij[i]=0.0;
        for(k=0; k<nsc ; k++){
             if( i < k ) rij[i] += dist[i][k];
             if( i > k ) rij[i] += dist[k][i];
         }
      }
     for(i=0; i<nsc-1; i++){
          for(j=i+1; j<nsc; j++){
          st[scnt]=dist[i][j]*ds-rij[i]-rij[j];
          spair[scnt][0]=i;
          spair[scnt][1]=j;
          if( scnt == 0 ) {
             sm=st[0];
             nsm = 0;
	   }else{
            if( st[scnt] < sm ){
               sm = st[scnt];
               nsm = scnt;
	     }
	  }
          scnt++;
	}
      }
/*
      sw[0]=nsm;
      nsw=1;
      for(i=0; i<scnt ; i++){
         if( i == nsm ) continue;
         dw = st[i]-sm;
         if( dw < 0.0 ) dw *= -1.0;
         if( dw <= ACU ) {
           sw[nsw]=i;
           nsw++;
         }
       }
       if( nsw > 1 ){
          rn = random()%nsw;
          nsm = sw[rn];
	}
*/
      n1=spair[nsm][0];
      n2=spair[nsm][1];
      node[cyc][0]=otu[n1];
      node[cyc][1]=otu[n2];
      dcm[cyc]=dist[n1][n2];
      branch0[cyc][0]=dist[n1][n2]/2.0+(rij[n1]-rij[n2])/(2.0*ds);
      branch0[cyc][1]=dist[n1][n2]/2.0+(rij[n2]-rij[n1])/(2.0*ds);
      if( otu[n1] > nseq ){
         n3=otu[n1]-nseq-1;
         branch0[cyc][0] -= dcm[n3]/2.0;
       }
      if( otu[n2] > nseq ){
         n3=otu[n2]-nseq-1;
         branch0[cyc][1] -= dcm[n3]/2.0;
       }
      for(k=0; k<nsc; k++) {
          if( k == n1 || k == n2 ) continue;
          if( n1 < k && n2 < k ) dist[n1][k] = (dist[n1][k] + dist[n2][k])/2.0;
          if( n1 < k && n2 > k ) dist[n1][k] = (dist[n1][k] + dist[k][n2])/2.0;
          if( n1 > k && n2 < k ) dist[k][n1] = (dist[k][n1] + dist[n2][k])/2.0;
          if( n1 > k && n2 > k ) dist[k][n1] = (dist[k][n1] + dist[k][n2])/2.0;
	}
      otu[n1]=nseq+cyc+1;
      for(k=n2; k<nsc-1; k++) otu[k]=otu[k+1];

      for(k=0; k< n2 ; k++){
         for(l=n2+1 ; l< nsc ; l++)  dist[k][l-1] = dist[k][l];
       }
       for(k=n2+1 ; k<nsc-1 ; k++){
         for(l=k+1 ; l<nsc ; l++) dist[k-1][l-1] =dist[k][l];
       }

   
     

/*      for(k=0; k<nsc ; k++){
        for(l=n2; l<nsc-1; l++){
           dist[k][l] =dist[k][l+1];
	 }
       }
      for(k=0; k<nsc ; k++){
         for(l=n2; l<nsc-1 ; l++){
           dist[l][k] =dist[l+1][k];
         }
       }
*/
       nsc--;
   
}

cyc=nseq-3;
 branch0[cyc][0]=(dist[0][1]+dist[0][2]-dist[1][2])/2.0;
 branch0[cyc][1]=(dist[0][1]-dist[0][2]+dist[1][2])/2.0;
 branch0[cyc][2]=(-dist[0][1]+dist[0][2]+dist[1][2])/2.0;
 for(i=0; i<3 ; i++){
   node[cyc][i]=otu[i];
   if( otu[i] > nseq ){
         n3=otu[i]-nseq-1;
         branch0[cyc][i] -= dcm[n3]/2.0;
       }
 }

 return(0);
}
           

njr(nseq,dist,node,branch0,otu,spair,sw,st,dcm,rij,seed1,accu)
int nseq,**node/*[MAXOTU-2][3]*/,*seed1;
int *otu/*[MAXOTU]*/,**spair/*[MAXOTU*(MAXOTU-1)/2][2]*/,*sw/*[MAXOTU*(MAXOTU-1)/2]*/;
double *st/*[MAXOTU*(MAXOTU-1)/2]*/,*dcm/*[MAXOTU]*/,*rij/*[MAXOTU]*/;
double **dist/*[MAXOTU][MAXOTU]*/,**branch0/*[MAXOTU][3]*/,accu;
{
int i,j,k,l,nsc,cyc,comb,tie,scnt,n1,n2,n3,nsm,nsw,rn;
double dw,s1,s2,s3,s,sm,ri,rj,ds;
double s12,s34,s56,s78;
float ran1();

  nsc=nseq;
  
  for(i=0; i<nseq-2 ; i++){
    for(j=0; j<3 ; j++) node[i][j]=0;
  }
  for(i=0; i<nseq; i++) otu[i]=i+1;
  for(cyc=0; cyc<nseq-3; cyc++){
     tie=0;
     scnt=0;
     ds=nsc-2;
     for(i=0; i<nsc ; i++){
        rij[i]=0.0;
        for(k=0; k<nsc ; k++){
             if( i < k ) rij[i] += dist[i][k];
             if( i > k ) rij[i] += dist[k][i];
         }
      }
     for(i=0; i<nsc-1; i++){
          for(j=i+1; j<nsc; j++){
          st[scnt]=dist[i][j]*ds-rij[i]-rij[j];
          spair[scnt][0]=i;
          spair[scnt][1]=j;
          if( scnt == 0 ) {
             sm=st[0];
             nsm = 0;
	   }else{
            if( st[scnt] < sm ){
               sm = st[scnt];
               nsm = scnt;
	     }
	  }
          scnt++;
	}
      }
      sw[0]=nsm;
      nsw=1;
      for(i=0; i<scnt ; i++){
         if( i == nsm ) continue;
         dw = st[i]-sm;
         if( dw < 0.0 ) dw *= -1.0;
         if( dw < accu ) {
           sw[nsw]=i;
           nsw++;
         }
       }
       if( nsw > 1 ){
/*          rn = random()%nsw; */
          rn = ran1(seed1)*(float)nsw;
          nsm = sw[rn];
	}
      n1=spair[nsm][0];
      n2=spair[nsm][1];
      node[cyc][0]=otu[n1];
      node[cyc][1]=otu[n2];
      dcm[cyc]=dist[n1][n2];
      branch0[cyc][0]=dist[n1][n2]/2.0+(rij[n1]-rij[n2])/(2.0*ds);
      branch0[cyc][1]=dist[n1][n2]/2.0+(rij[n2]-rij[n1])/(2.0*ds);
      if( otu[n1] > nseq ){
         n3=otu[n1]-nseq-1;
         branch0[cyc][0] -= dcm[n3]/2.0;
       }
      if( otu[n2] > nseq ){
         n3=otu[n2]-nseq-1;
         branch0[cyc][1] -= dcm[n3]/2.0;
       }
      for(k=0; k<nsc; k++) {
          if( k == n1 || k == n2 ) continue;
          if( n1 < k && n2 < k ) dist[n1][k] = (dist[n1][k] + dist[n2][k])/2.0;
          if( n1 < k && n2 > k ) dist[n1][k] = (dist[n1][k] + dist[k][n2])/2.0;
          if( n1 > k && n2 < k ) dist[k][n1] = (dist[k][n1] + dist[n2][k])/2.0;
          if( n1 > k && n2 > k ) dist[k][n1] = (dist[k][n1] + dist[k][n2])/2.0;
	}
      otu[n1]=nseq+cyc+1;
      for(k=n2; k<nsc-1; k++) otu[k]=otu[k+1];

      for(k=0; k< n2 ; k++){
         for(l=n2+1 ; l< nsc ; l++)  dist[k][l-1] = dist[k][l];
       }
       for(k=n2+1 ; k<nsc-1 ; k++){
         for(l=k+1 ; l<nsc ; l++) dist[k-1][l-1] =dist[k][l];
       }

   
     

/*      for(k=0; k<nsc ; k++){
        for(l=n2; l<nsc-1; l++){
           dist[k][l] =dist[k][l+1];
	 }
       }
      for(k=0; k<nsc ; k++){
         for(l=n2; l<nsc-1 ; l++){
           dist[l][k] =dist[l+1][k];
         }
       }
*/
       nsc--;
   
}

cyc=nseq-3;
 branch0[cyc][0]=(dist[0][1]+dist[0][2]-dist[1][2])/2.0;
 branch0[cyc][1]=(dist[0][1]-dist[0][2]+dist[1][2])/2.0;
 branch0[cyc][2]=(-dist[0][1]+dist[0][2]+dist[1][2])/2.0;
 for(i=0; i<3 ; i++){
   node[cyc][i]=otu[i];
   if( otu[i] > nseq ){
         n3=otu[i]-nseq-1;
         branch0[cyc][i] -= dcm[n3]/2.0;
       }
 }

 return(0);
}
           

/* distance caluculation routines */
gmadis(dd,ntt,nts,ntv,gammaa)
double *dd,gammaa;
int ntt,nts,ntv;
{
double dp,dq,dc1,dc2,dnt,dw1,dw2;
double pow(),sqrt();
dnt=ntt;
dp=nts;
dp /= dnt;
dq = ntv;
dq /= dnt;

dw1 = pow(1.0-2.0*dp-dq,-1.0/gammaa);
dw2 = pow(1.0-2.0*dq,-1.0/gammaa);
*dd = gammaa*0.5*(dw1+0.5*dw2-1.5);
/* printf("gamma=%f %d %d %d\n",gammaa,ntt,nts,ntv);*/
return(0);
}


/* Tamura (3) diatance */
tm3dis(dd,cnh,ntt,nts,ntv)
double *dd;
int cnh[4][4],ntt,nts,ntv;
{
int i,j,ngc;
double p,q,dw,theta; /* theta: GC-content */
double da,db,dt,ds,dv,dl1,dl2;
double log(),sqrt();
dt=ntt;
ds=nts;
dv=ntv;
p=ds/dt;
q=dv/dt;

ngc=0;
for(i=0; i<4; i++){
  for(j=0; j<4 ; j++){
     if( i == 2 ) ngc += cnh[i][j];
     if( i == 3 ) ngc += cnh[i][j];
     if( j == 2 ) ngc += cnh[i][j];
     if( j == 3 ) ngc += cnh[i][j];
   }
}
theta = ngc;
theta /= 2.0*ntt;
dl1 = log(1.0-p/(2.0*theta*(1.0-theta))- q);
dl2= log(1.0-2.0*q);
*dd = -2.0*theta*(1.0-theta)*dl1-(1.0-2.0*theta*(1.0-theta))*dl2/2.0;
 return(0);
}      



/* calculate Tajima-Nei distance */
tndis(dd,cnh,ntt,ndif)
double *dd;
int cnh[4][4],ntt,ndif;
{
int i,j,nt,g[4];
double log(),sqrt(), dw,dg[4],dnt,dc,db,dp,dt,dvar;

dt=ntt;
dp=ndif;
dp /= dt;
if( ndif == 0 ){
     *dd=0.0;
     return(0);
   }
/* printf("dp=%f ",dp); */
for(i=0; i<4; i++) g[i]=0;
nt=0;
for(i=0; i<4; i++){
 for(j=0; j<4 ; j++){
    g[i] += cnh[i][j];
    g[j] += cnh[i][j];
    nt += 2*cnh[i][j];
  }
}

dnt = nt;
for(i=0; i<4; i++){
  dg[i] = g[i];
  dg[i] /= dnt;
/* printf("g[%d]=%f nt=%d",i,dg[i],nt);  */
}

/* printf("gt=%f\n g=%d",dg[0]+dg[1]+dg[2]+dg[3],g[0]+g[1]+g[2]+g[3]); */
dc=0.0;
for(i=0; i<3; i++){
  for(j=i+1; j<4 ; j++){
     if( cnh[i][j]+cnh[j][i] == 0 ) continue;
     dw = cnh[i][j]+cnh[j][i];
     dw /= dt;
/*     printf("%c%c x=%f ",base[i],base[j],dw); */
     dc += dw*dw/(2.0*dg[i]*dg[j]);
   }
}
db = 1.0+dp*dp/dc;
for(i=0; i<4; i++) db -= dg[i]*dg[i];
db /= 2.0;
if( 1.0 - dp/db <= 0.0 ) return(-1);
*dd = -db*log(1.0 - dp/db);

return(0);
}
/* calculate Jukes-Cantor distance */
int jcdis(dd,nt,nd)
double *dd;
int nd,nt;
{
double dn,dp,dva,log(),sqrt();
dn = nt;
dp  = nd;
dp /= dn;
if( 1.0-dp*4.0/3.0 <= 0.0 ) return(-1);
*dd = -0.75*log(1.0-dp*4.0/3.0);
/* printf("dd=%f dp=%f\n",*dd,dp); */
return(0);
}
/* calculate Kimura's two parameter distance */

int k2pdis(dd,nt,ns,nv)
double *dd;
int nt,ns,nv;
{
double dt,dn, da,db,dp,dq,log(),sqrt(),dva,dsq;
dp = ns;
dq = nv;
dt = nt;
dp /= dt;
dq /= dt;
/* printf("nt=%d ns=%d nv=%d\n",nt,ns,nv); */
if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
if( 1.0-2.0*dp-dq <= 0.0 ) return(-1);
dsq = sqrt(1.0- 2.0*dq);
*dd = log((1.0-2.0*dp-dq)*dsq);

*dd *= -0.5;
return(0);
}


njtndp(nseq,node,nodes,ncn)
int nseq,**node/*[MAXOTU-1][3]*/;
Nodc **nodes/*[MAXOTU-2]*/;
char *ncn/*[MAXOTU-2]*/;
{
int i,j,k,nc,flg;


for(i=0; i<nseq-2 ; i++){
   nc=2;
   ncn[i]=0;
   if( i == nseq-3 ) nc=3;
   for(j=0; j<nc ; j++) {
      if( node[i][j] <= nseq ){
          nodes[i]->childn[j]=node[i][j];
          nodes[i]->childio[j]= 0;
          continue;
	}
        nodes[i]->childn[j]=node[i][j]-nseq;
        nodes[i]->childio[j]= 1;
    }
}
for(i=0; i<nseq-3; i++){
  flg =0;
  for(j=0; j<nseq-2; j++){
    if( i == j ) continue;
    nc=2;
    if( j == nseq-3 ) nc=3;
    for(k=0; k<nc ; k++){
      if( node[j][k] == i+nseq+1 ) {
        flg =1;
        nodes[i]->childn[2]=j+1;
        nodes[i]->childio[2]= 1;
        break;
      }
    }
    if( flg == 1) break;
  }
}

if( dflg == 2){
   for(i=0; i<nseq-2 ; i++){
     printf("nodes %d:",i);
     for(j=0;j<3 ; j++) printf("%d %d  ",nodes[i]->childio[j],nodes[i]->childn[j]);
     printf("\n");
   }
 }

if( dflg == 2){
   for(i=0; i<nseq-2 ; i++){
     printf("nodes %d:",i);
     for(j=0;j<3 ; j++) printf("%d %d  ",nodes[i]->childio[j],nodes[i]->childn[j]);
     printf("\n");
   }
 }
return(0);
}

parti(nseq,nodes,part,bri,rlo,rli,chf)
int nseq,**bri/*[MAXOTU-3][2]*/;
Nodc **nodes/*[MAXOTU-2]*/;
char **part/*[MAXOTU-3][MAXOTU]*/,*rlo,*rli,*chf;
{
int i,j,k,nb,flg;
int nbri,nr,nl,or,ol,ns;
/* char rlo[MAXOTU],rli[MAXOTU-2],chf[MAXOTU-2];*/

/* printf("parti start nseq=%d\n",nseq);  */
nbri=0;
for(i=0; i<nseq-2; i++){
  for(j=0; j<3 ; j++) {
    if(  nodes[i]->childio[j] ==  1 && nodes[i]->childn[j] < i+1 ){
         bri[nbri][0]= nodes[i]->childn[j];
         bri[nbri][1]= i+1;
/*         printf("%d   %d %d\n",nbri,bri[nbri][0],bri[nbri][1]);  */
         nbri++;
       }
  }
}
/*  for(i=0; i<nseq-2; i++) printf("node %d  %d (%d) %d (%d) %d (%d)\n",i,nodes[i].childn[0],nodes[i].childio[0],nodes[i].childn[1],nodes[i].childio[1],nodes[i].childn[2],nodes[i].childio[2]);
    }
*/
if( nbri != nseq-3 ){
    printf("number of internal branches invalid %d\n",nbri);
    exit(1);
  }

for(nb=0; nb < nbri ; nb++){
   for(i=0; i<nseq-2 ; i++){
        chf[i]=0;
        rli[i]=' ';
      }
   for(i=0; i<nseq ; i++) {
     rlo[i]=' ';
     part[nb][i]=0;
   }
   or=bri[nb][0];
   ol=bri[nb][1];
   nr=0;
   nl=0;
   for(i=0; i<3 ; i++){
      if( nodes[or-1]->childio[i] == 1 && nodes[or-1]->childn[i] == ol ) continue;
      switch(nodes[or-1]->childio[i] ){
          case 1:  rli[nodes[or-1]->childn[i]-1]='r';
                   break;
          case 0 :
                   rlo[nodes[or-1]->childn[i]-1]='r';
                   nr++;
                   break;
	}
    }
   for(i=0; i<3 ; i++){
      if( nodes[ol-1]->childio[i] == 1 && nodes[ol-1]->childn[i] == or ) continue;
      switch(nodes[ol-1]->childio[i]){
          case 1 :  rli[nodes[ol-1]->childn[i]-1]='l';
                    break;
          case 0 :  rlo[nodes[ol-1]->childn[i]-1]='l';
                    nl++;
                    break;
	}
    }
    chf[or-1]=1;
    chf[ol-1]=1;
    ns=2;
  for( ; ; ){
    for(i=0; i< nseq-2 ; i++){
/*
      printf("i=%d nseq=%d nb=%d ns=%d\n",i,nseq,nb,ns); 
      printf("chf ");
      for(j=0; j< nseq-2 ; j++) printf(" %d",chf[j]);
      printf("\n");
      printf("rli ");
      for(j=0; j< nseq-2 ; j++) printf(" %c",rli[j]);
      printf("\n");
      printf("rlo ");
      for(j=0; j< nseq ; j++) printf(" %c",rlo[j]);
      printf("\n");
*/
      if( ns >= nseq-2 && nseq == 4 ) goto S1;
      if( chf[i] == 1 ) continue;
      if( rli[i] == ' '  ) continue; 
      switch( rli[i] ){
         case  'r':
                   for(j=0; j<3 ; j++){
                     if( nodes[i]->childio[j] == 1 && rli[nodes[i]->childn[j]-1] == 'r' )
 continue;
                     switch(nodes[i]->childio[j]) {
                       case 1 : rli[nodes[i]->childn[j]-1]='r';
                                break;
                       case 0 : 
                                rlo[nodes[i]->childn[j]-1]='r';
                                nr++;
                                break;
		     }
		   }
                    ns++;
/*                    printf("ns=%d nseq=%d (1)\n",ns,nseq);*/
                    if( ns >= nseq-2 ) goto S1;
                    break;
        case  'l' :
           for(j=0; j<3 ; j++){
             if( nodes[i]->childio[j] == 1 && rli[nodes[i]->childn[j]-1] == 'l' )
continue;
             switch( nodes[i]->childio[j]) {
                 case 1 : rli[nodes[i]->childn[j]-1]='l';
                          break;
                 case 0 : 
                          rlo[nodes[i]->childn[j]-1]='l';
                          nl++;
		  }
	   }
           ns++;
/*           printf("ns=%d nseq=%d (2)\n",ns,nseq); */
           if( ns >= nseq-2 ) goto S1;
           break;
		 }
        chf[i]=1;
    }
  }
S1:    if( nl+nr != nseq ) {
      printf("nl=%d nr=%d nseq=%d\n",nl,nr,nseq);
      exit(1);
    }
/*     printf("nl=%d nr=%d nseq=%d\n",nl,nr,nseq); */
   
    if( nl < nr ){
        for(i=0; i<nseq ; i++){
          if( rlo[i] == 'l' ) part[nb][i]=1;
        }
      }
    if( nl >= nr ){
        for(i=0; i<nseq ; i++){
          if( rlo[i] == 'r' ) part[nb][i]=1;
        }
      }
/*
    printf("rlo:");
    for(i=0; i<nseq ; i++){
      printf(" %c",rlo[i]);
    }
    printf("\n");
    printf("part:");
    for(i=0; i<nseq ; i++){
      printf(" %d",part[nb][i]);
    }
    printf("\n");
*/

  
 }

  
if( dflg == 1 ) {
   for(i=0; i<nseq-3 ; i++){
     for(j=0; j<nseq ; j++){
        printf(" %d",part[i][j]);
      }
     printf("\n");
   }
 }
/*  printf("parti return\n");  */
return(0);
}


ressite(nasite,asite,rsite,psite,npsite,sitef,seed)
int nasite, *asite,*rsite,*psite,*npsite,*sitef,*seed;
{
int i,rn;
float ran1();
*npsite=0;
for(i=0; i<nasite ; i++){
/*   rn=random()%nasite; */
   rn= ran1(seed)*(float)(nasite); 
/*   printf("rn=%d\n",rn);*/
   rsite[i]=asite[rn];
   if( sitef[asite[rn]] == 2 ){
       psite[*npsite]=rn;
       (*npsite)++;
     }
/*   printf("i=%d rn=%d asite[%d]=%d\n",i,rn,rn,asite[rn]); */
 }
/* printf("\n"); */
return(0);
}
caldist(nseq,npop,popseq,dxall,dx,dxy,dxs,dxss,dxys,das,distw,nseqp,a,fl,nasite,rsite,npsite,psite,dop,fpo,gamma,bootflg,dxyflg,negflg)
FILE *fpo;
char **a/*[MAXSITE][MAXOTU]*/,**fl/*[MAXOTU][MAXNM]*/;
int nseq,npop,**popseq,*nseqp,nasite, *rsite,dop,npsite,*psite,bootflg,dxyflg;
int negflg;
double gamma,*dxall,*dx,**dxy,**dxys,**das,**distw,*dxs,*dxss;
{
int rn,i,j,k,l,l1,i1,j1,cnch[4][4],cw,b1,b2,nts,ntv,nid,ndf,nts1,nts2,nb[5],na,nt,n1,n2;
double dp,ga,gt,gg,gc,gr,gy,dw1,dw2,dw3,dp1,dp2,dw,dq,max=0.00,dw0;

*dxall = 0.;
*nseqp=0;
for(i=0; i< npop ; i++) {
  dx[i] = 0.;
  for(j=0; j< npop ; j++){
     dxy[i][j] = dxy[j][i] = 0.;
   }
}

if( dop == 10 || dop == 11  || dop == 17){
  for(i1=0; i1< npop ; i1++){
    n1 = popseq[i1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=i+1; j <= popseq[i1][1]-1; j++){
         nts1=0;nts2=0;ntv=0;
         nid=0;ndf=0;
         for(k=0; k<npsite ; k++){
            b1= a[psite[k]][i];
            b2= a[psite[k]][j];
            if( b1 >= 5 || b2 >= 5 ) continue;
            switch(trp[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : ndf++;
                        break;
          }
        }
        if( nid+ndf == 0 ) return(-10);
        dw = ndf;
        dw /= nasite;
        dx[i1] += dw;
        *dxall += dw;
        (*nseqp)++;
       }
      }
      dx[i1] /= n1*(n1-1)/2;
      if( bootflg == 1 ){
        dxs[i1] += dx[i1];
        dxss[i1] += dx[i1]*dx[i1];
      }
  }
  for(i1=0; i1< npop -1 ; i1++){
    n1 = popseq[i1][2];
    for(j1=i1+1; j1<npop ; j1++){
      n2 = popseq[j1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=popseq[j1][0]-1; j <= popseq[j1][1]-1; j++){
         nts1=0;nts2=0;ntv=0;
         nid=0;ndf=0;
         for(k=0; k<npsite ; k++){
            b1= a[psite[k]][i];
            b2= a[psite[k]][j];
            if( b1 >= 5 || b2 >= 5 ) continue;
            switch(trp[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : ndf++;
                        break;
          }
        }
        if( nid+ndf == 0 ) return(-10);
        dw = ndf;
        dw /= nasite;
        dxy[j1][i1] += dw;
        *dxall += dw;
        (*nseqp)++;
       }
      }

        dxy[j1][i1] /= n1*n2;
        dxy[i1][j1]  = dxy[j1][i1] - (dx[i1] + dx[j1]) /2.0;
        if( bootflg == 1 ){
           dxys[i1][j1] += dxy[j1][i1];
           dxys[j1][i1] += dxy[j1][i1]*dxy[j1][i1];
           das[i1][j1] += dxy[i1][j1];
           das[j1][i1] += dxy[i1][j1]*dxy[i1][j1];
           if( dxyflg == 0  ) {
               if( negflg == 1 ) {
                  distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
		}else{
                  if( dxy[i1][j1] >= 0. )  distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
                  else distw[i1][j1] = distw[j1][i1] = 0.;
		}
	     }
           if( dxyflg == 1 ) {
              if( negflg == 1 ){
                  distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
		}else{
                  if( dxy[j1][i1] >= 0. ) distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
                  else distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];

		}
	    }
	 }
    }
  }
/*      printf("\n"); */

  return(0); 
}




if( dop == 5 || dop == 6 || dop == 7 ){
  for(i1=0; i1< npop ; i1++){
    n1 = popseq[i1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=i+1; j <= popseq[i1][1]-1; j++){
         ndf=0;
         nid=0;
         for(k=0; k<npsite ; k++){
            b1= a[psite[k]][i];
            b2= a[psite[k]][j];
            if( b1 >= 20 || b2 >= 20 ) continue;
            if( b1 == b2 ) nid++;
            if( b1 != b2 ) ndf++;
        }
        if( nid+ndf == 0 ) return(-10);
        switch(dop){
           case 6: dw = ndf;
                   dw /= nasite;
                   break;
           case 5: dp = ndf;
                   dp /= nasite;
                   if( 1.0-dp/0.95 <= 0.0 ){
                      if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                      return(-1);
		    }
                   dw = -0.95*log(1.0-dp/0.95);
                   break;
           case 7: dp = ndf;
                   dp /= nasite;
                   if( 1.0-dp/0.95 <= 0.0 ){
                      if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                      return(-1);
		    }
                   dw = 1.0-dp/0.95;
                   dw = 0.95*gamma*(pow(dw,-1.0/gamma)-1.0);
                   break;
	
	   }
        dx[i1] += dw;
        *dxall += dw;
        (*nseqp)++;

       }
      }
     dx[i1] /= n1*(n1-1)/2;
     if( bootflg == 1 ){
        dxs[i1] += dx[i1];
        dxss[i1] += dx[i1]*dx[i1];
     }

  }

  for(i1=0; i1< npop -1 ; i1++){
    n1 = popseq[i1][2];
    for(j1=i1+1; j1<npop ; j1++){
      n2 = popseq[j1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=popseq[j1][0]-1; j <= popseq[j1][1]-1; j++){
         ndf=0;
         nid=0;
         for(k=0; k<npsite ; k++){
            b1= a[psite[k]][i];
            b2= a[psite[k]][j];
            if( b1 >= 20 || b2 >= 20 ) continue;
            if( b1 == b2 ) nid++;
            if( b1 != b2 ) ndf++;
        }
        if( nid+ndf == 0 ) return(-10);
        switch(dop){
           case 6: dw = ndf;
                   dw /= nasite;
                   break;
           case 5: dp = ndf;
                   dp /= nasite;
                   if( 1.0-dp/0.95 <= 0.0 ){
                      if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                      return(-1);
		    }
                   dw = -0.95*log(1.0-dp/0.95);
                   break;
           case 7: dp = ndf;
                   dp /= nasite;
                   if( 1.0-dp/0.95 <= 0.0 ){
                      if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                      return(-1);
		    }
                   dw = 1.0-dp/0.95;
                   dw = 0.95*gamma*(pow(dw,-1.0/gamma)-1.0);
                   break;
	
	   }
           dxy[j1][i1] += dw;
           *dxall += dw;
           (*nseqp)++;
       }
      }
      dxy[j1][i1] /= n1*n2;
      dxy[i1][j1]  = dxy[j1][i1] - (dx[i1] + dx[j1]) /2.0;
      if( bootflg == 1 ){
           dxys[i1][j1] += dxy[j1][i1];
           dxys[j1][i1] += dxy[j1][i1]*dxy[j1][i1];
           das[i1][j1] += dxy[i1][j1];
           das[j1][i1] += dxy[i1][j1];
           if( dxyflg == 0 ) {
                 if( negflg == 1 ) distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
                 else{
                       if( dxy[i1][j1] >= 0. ) distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
                       else{ distw[i1][j1] = distw[j1][i1] = 0.;}
		     }
	       }
           if( dxyflg == 1 ) {
                if( negflg == 1 ) distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
                else{
                   if( dxy[j1][i1] >= 0. ) distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
                   else{ distw[i1][j1] = distw[j1][i1] = 0.;
		       }
		 }
	      }
                      
	 }


    }
  }

  return(0);
}


if( dop == 8 || dop == 9  || dop == 15 || dop == 16 ){
  for(i1=0; i1< npop ; i1++){
    n1 = popseq[i1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=i+1; j <= popseq[i1][1]-1; j++){
/*         printf("i=%d j=%d\n",i,j); */
          nts1=nts2=ntv=0;
          nid=0;
          nb[0]=nb[1]=nb[2]=nb[3]=nb[4]=0;
          for(k=0; k<nasite ; k++){
            b1= a[rsite[k]][i];
            b2= a[rsite[k]][j];
            if( b1 >= 4 ) continue;
            if( b2 >= 4 ) continue;
            nb[b1]++;
            nb[b2]++;
            switch(tr1[b1][b2]){
         	    case 0:   nid++;
                              break;
         	    case 1:   nts1++;
                              break;
         	    case 2:   nts2++;
                              break;
         	    case 3:   ntv++;
                              break;
		    }

        }
/*        printf("i=%d j=%d nid=%d nts1=%d nts2=%d ntv=%d \n",i,j,nid,nts1,nts2,ntv);  */
        if( nid+nts1+nts2+ntv == 0 ) return(-10);
        nt = nasite;
        na = (nid+nts1+nts2+ntv)*2;
        ga = nb[0];
        ga /= na;
        gt = nb[1];
        gt /= na;
        gg = nb[2];
        gg /= na;
        gc = nb[3];
        gc /= na;
        gr = ga + gg;
        gy = gt + gc;
        dp1 = nts1;
        dp2 = nts2;
        dq  = ntv;
        dp1 /= nt;
        dp2 /= nt;
        dq  /= nt;
        if( nts1+nts2+ntv == 0 ) {
            dw =0.0;
	  }else{
        dw1 = 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr);
        dw2 = 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy);
        dw3 = 1.0- dq/(2.0*gr*gy);

/*        printf("a t g c %f %f %f %f dw %f %f %f\n",ga,gt,gg,gc,dw1,dw2,dw3); */
        if( dop == 8 || dop == 9 ) if( 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr) <= 0.0 ) {
           if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
           return(-1);
	 }
        if( dop == 8 || dop == 9 ) if( 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy) <=0.0 ) {
                    if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                    return(-1);
		  }
        if( 1.0- dq/(2.0*gr*gy) <= 0.0 ) {
           if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
             return(-1);
	 }
        switch(dop){
           case 8: dw0 = ga*gg/(gr)*log(dw1) + gt*gc/(gy)*log(dw2) + (gr*gy-ga*gg*gy/gr - gt*gc*gr/gy)*log(dw3);
                   dw0  *= -2.0;
                   break;
           case 9:  dw0 = ga*gg/(gr)*pow(dw1,-1.0/gamma)+gt*gc/gy*pow(dw2,-1.0/gamma)+(gr*gy-ga*gg*gy/gr-gt*gc*gr/gy)*pow(dw3,-1.0/gamma) -ga*gg-gt*gc-gr*gy;
                   dw0 *= 2.0*gamma;
/*                   printf("gamma=%f %d %d %f\n",gamma,i,j,dist[i][j]); */
                   break;

           case 15:  dw0 = -2.0*gr*gy*log(1.0-dq/(2.0*gr*gy));
                     break;
           case 16:  dw0 = pow(1.0-dq/(2.0*gr*gy),-1.0/gamma)-1.0;
                     dw0 *= 2.0*gamma*gr*gy;
                     break;
                   

	   }
          }
          dx[i1] += dw0;
          *dxall += dw0;
          (*nseqp)++;

	}
      }
     dx[i1] /= n1*(n1-1)/2;
     if( bootflg == 1 ){
        dxs[i1] += dx[i1];
        dxss[i1] += dx[i1]*dx[i1];
     }

  }
  for(i1=0; i1< npop -1 ; i1++){
    n1 = popseq[i1][2];
    for(j1=i1+1; j1<npop ; j1++){
      n2 = popseq[j1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=popseq[j1][0]-1; j <= popseq[j1][1]-1; j++){
          nts1=nts2=ntv=0;
          nid=0;
          nb[0]=nb[1]=nb[2]=nb[3]=nb[4]=0;
          for(k=0; k<nasite ; k++){
            b1= a[rsite[k]][i];
            b2= a[rsite[k]][j];
            if( b1 >= 4 ) continue;
            if( b2 >= 4 ) continue;
            nb[b1]++;
            nb[b2]++;
            switch(tr1[b1][b2]){
         	    case 0:   nid++;
                              break;
         	    case 1:   nts1++;
                              break;
         	    case 2:   nts2++;
                              break;
         	    case 3:   ntv++;
                              break;
		    }

        }
/*        printf("i=%d j=%d nid=%d nts1=%d nts2=%d ntv=%d \n",i,j,nid,nts1,nts2,ntv);  */
        if( nid+nts1+nts2+ntv == 0 ) return(-10);
        nt = nasite;
        na = (nid+nts1+nts2+ntv)*2;
        ga = nb[0];
        ga /= na;
        gt = nb[1];
        gt /= na;
        gg = nb[2];
        gg /= na;
        gc = nb[3];
        gc /= na;
        gr = ga + gg;
        gy = gt + gc;
        dp1 = nts1;
        dp2 = nts2;
        dq  = ntv;
        dp1 /= nt;
        dp2 /= nt;
        dq  /= nt;
        if( nts1+nts2+ntv == 0 ) {
            dw0 =0.0;
	  }else{
        dw1 = 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr);
        dw2 = 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy);
        dw3 = 1.0- dq/(2.0*gr*gy);

/*        printf("a t g c %f %f %f %f dw %f %f %f\n",ga,gt,gg,gc,dw1,dw2,dw3); */
        if( dop == 8 || dop == 9 ) if( 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr) <= 0.0 ) {
           if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
           return(-1);
	 }
        if( dop == 8 || dop == 9 ) if( 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy) <=0.0 ) {
                    if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                    return(-1);
		  }
        if( 1.0- dq/(2.0*gr*gy) <= 0.0 ) {
           if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
             return(-1);
	 }
        switch(dop){
           case 8: dw0 = ga*gg/(gr)*log(dw1) + gt*gc/(gy)*log(dw2) + (gr*gy-ga*gg*gy/gr - gt*gc*gr/gy)*log(dw3);
                   dw0  *= -2.0;
                   break;
           case 9:  dw0 = ga*gg/(gr)*pow(dw1,-1.0/gamma)+gt*gc/gy*pow(dw2,-1.0/gamma)+(gr*gy-ga*gg*gy/gr-gt*gc*gr/gy)*pow(dw3,-1.0/gamma) -ga*gg-gt*gc-gr*gy;
                   dw0 *= 2.0*gamma;
/*                   printf("gamma=%f %d %d %f\n",gamma,i,j,dist[i][j]); */
                   break;

           case 15:  dw0 = -2.0*gr*gy*log(1.0-dq/(2.0*gr*gy));
                     break;
           case 16:  dw0 = pow(1.0-dq/(2.0*gr*gy),-1.0/gamma)-1.0;
                     dw0 *= 2.0*gamma*gr*gy;
                     break;
   	   }
      }
           dxy[j1][i1] += dw0;
           *dxall += dw0;
           (*nseqp)++;
	}
      }
      dxy[j1][i1] /= n1*n2;
      dxy[i1][j1]  = dxy[j1][i1] - (dx[i1] + dx[j1]) /2.0;
      if( bootflg == 1 ){
           dxys[i1][j1] += dxy[j1][i1];
           dxys[j1][i1] += dxy[j1][i1]*dxy[j1][i1];
           das[i1][j1] += dxy[i1][j1];
           das[j1][i1] += dxy[i1][j1]*dxy[i1][j1];
           if( dxyflg == 0 ) {
                if( negflg == 1 ) distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
                if( negflg == 0 && dxy[i1][j1] >= 0. ) distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
                if( negflg == 0 && dxy[i1][j1] < 0. ) distw[i1][j1] = distw[j1][i1] =  0.;
	      }
           if( dxyflg == 1 ) {
                if( negflg == 1 ) distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
                if( negflg == 0 && dxy[j1][i1] >= 0. )  distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
                if( negflg == 0 && dxy[j1][i1] < 0. )  distw[i1][j1] = distw[j1][i1] = 0.;
       }


	 }
    }
  }
/*  printf("max=%f\n",max); */
  return(0);
  }

if( dop == 2 || dop == 3 ){
/*  printf("dop=%d\n",dop); */
/*  for(i=0; i<nasite ; i++) printf("%d ",rsite[i]); */
/*  printf("\n"); */
  for(i1=0; i1< npop ; i1++){
    n1 = popseq[i1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=i+1; j <= popseq[i1][1]-1; j++){
         for(k=0; k<4; k++){
           for(l=0; l<4 ; l++){
              cnch[k][l]=0;
            }
         }
         nts=0;
         ntv=0;
         nid=0;
         for(k=0; k<nasite ; k++){
          b1= a[rsite[k]][i];
          b2= a[rsite[k]][j];
          if( b1 >= 4 ) continue;
          if( b2 >= 4 ) continue;
          switch(tr[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : nts++;
                        break;
                case 1: ntv++;
                        break;
          }
          cnch[b1][b2]++; 

     }
     if(   nts+ntv == 0 ){
        dw0=0.;
      }else{
        rn=caldis(cnch,i,j,fl,fpo,&dw0,dop,nid,nts,ntv,nasite,gamma);
        if( rn != 0  ) return(rn);
      }
    dx[i1] += dw0;
    (*dxall) += dw0;
    (*nseqp)++;
/*    printf("dxall=%f nseqp=%d\n",*dxall,*nseqp); */
        }
      }
     dx[i1] /= n1*(n1-1)/2;
     if( bootflg == 1 ){
        dxs[i1] += dx[i1];
        dxss[i1] += dx[i1]*dx[i1];
     }

  }

  for(i1=0; i1< npop -1 ; i1++){
    n1 = popseq[i1][2];
    for(j1=i1+1; j1<npop ; j1++){
      n2 = popseq[j1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=popseq[j1][0]-1; j <= popseq[j1][1]-1; j++){
         for(k=0; k<4; k++){
           for(l=0; l<4 ; l++){
              cnch[k][l]=0;
            }
         }
         nts=0;
         ntv=0;
         nid=0;
         for(k=0; k<nasite ; k++){
          b1= a[rsite[k]][i];
          b2= a[rsite[k]][j];
          if( b1 >= 4 ) continue;
          if( b2 >= 4 ) continue;
          switch(tr[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : nts++;
                        break;
                case 1: ntv++;
                        break;
          }
          cnch[b1][b2]++; 

     }
    if(  nts+ntv == 0 ){
          dw0 = 0.;
	}else{
/*    printf("%d %s  %d %s   %d %d %d\n",i,fl[i],j,fl[j],nid+nts+ntv,nts,ntv);*/
      rn=caldis(cnch,i,j,fl,fpo,&dw0,dop,nid,nts,ntv,nasite,gamma);
      if( rn != 0 ) return(-10);
    }
      dxy[j1][i1] += dw0;
           *dxall += dw0;
           (*nseqp)++;
/*           printf("dxall=%f nseqp=%d\n",*dxall,*nseqp); */
       }
      }
      dxy[j1][i1] /= n1*n2;
      dxy[i1][j1]  = dxy[j1][i1] - (dx[i1] + dx[j1]) /2.0;
      if( bootflg == 1 ){
           dxys[i1][j1] += dxy[j1][i1];
           dxys[j1][i1] += dxy[j1][i1]*dxy[j1][i1];
           das[i1][j1] += dxy[i1][j1];
           das[j1][i1] += dxy[i1][j1]*dxy[i1][j1];
           if( dxyflg == 0 ){
                if( negflg == 1 ) distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
                if( negflg == 0 && dxy[i1][j1] >= 0. ) distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
                if( negflg == 0 && dxy[i1][j1] < 0. ) distw[i1][j1] = distw[j1][i1] = 0.;
	      }
           if( dxyflg == 1 ) {
                if( negflg == 1 ) distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
                if( negflg == 0 && dxy[j1][i1] >= 0.  ) distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
                if( negflg == 0 && dxy[j1][i1] < 0.  ) distw[i1][j1] = distw[j1][i1] = 0.;

	      }
	 }
    }
  }
/*  printf("dxall=%f nseqp=%d\n",*dxall,*nseqp); */
  return(0);

}

/* printf("dop=%d\n",dop); fflush(stdout); */
for(i1=0; i1< npop ; i1++){
    n1 = popseq[i1][2];
    for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
     for(j=i+1; j <= popseq[i1][1]-1; j++){
/*       printf("i1=%d i=%d j=%d\n",i1,i,j);fflush(stdout); */
       nts=0;
       ntv=0;
       nid=0;
       for(k=0; k<npsite ; k++){
/*         printf("psite[%d]=%d\n",k,psite[k]);fflush(stdout); */
          b1= a[psite[k]][i];
          b2= a[psite[k]][j];
          if( b1 >= 4 ) continue;
          if( b2 >= 4 ) continue;
          switch(tr[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : nts++;
                        break;
                case 1: ntv++;
                        break;
          }
	}
     if( nts+ntv == 0 ) {
      dw0=0.;
     }else{
/*    printf("%d %s  %d %s   %d %d %d\n",i,fl[i],j,fl[j],nid+nts+ntv,nts,ntv); fflush(stdout); */
     rn=caldis(cnch,i,j,fl,fpo,&dw0,dop,nasite-nts-ntv,nts,ntv,nasite,gamma);
      if( rn != 0  ) return(rn);
  }
    dx[i1] += dw0;
    *dxall += dw0;
    (*nseqp)++;
        }
      }
     dx[i1] /= n1*(n1-1)/2;
     if( bootflg == 1 ){
        dxs[i1] += dx[i1];
        dxss[i1] += dx[i1]*dx[i1];
     }
  }
/*  printf("end of dx\n"); fflush(stdout); */
 for(i1=0; i1< npop -1 ; i1++){
    n1 = popseq[i1][2];
    for(j1=i1+1; j1<npop ; j1++){
      n2 = popseq[j1][2];
       for(i=popseq[i1][0]-1 ; i<=popseq[i1][1]-1 ; i++){
        for(j=popseq[j1][0]-1; j <= popseq[j1][1]-1; j++){
         nts=0;
         ntv=0;
         nid=0;
         for(k=0; k<npsite ; k++){
          b1= a[psite[k]][i];
          b2= a[psite[k]][j];
          if( b1 >= 4 ) continue;
          if( b2 >= 4 ) continue;
          switch(tr[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : nts++;
                        break;
                case 1: ntv++;
                        break;
          }
	}
     if(  nts+ntv == 0 ) {
           dw0=0.;
      }else{
/*    printf("%d %s  %d %s   %d %d %d\n",i,fl[i],j,fl[j],nid+nts+ntv,nts,ntv);*/
      rn=caldis(cnch,i,j,fl,fpo,&dw0,dop,nasite-nts-ntv,nts,ntv,nasite,gamma);
      if( rn != 0  ) return(rn);
    }
           dxy[j1][i1] += dw0;
           *dxall += dw0;
           (*nseqp)++;
       }
      }
      dxy[j1][i1] /= n1*n2;
      dxy[i1][j1]  = dxy[j1][i1] - (dx[i1] + dx[j1]) /2.0;
      if( bootflg == 1 ){
           dxys[i1][j1] += dxy[j1][i1];
           dxys[j1][i1] += dxy[j1][i1]*dxy[j1][i1];
           das[i1][j1] += dxy[i1][j1];
           das[j1][i1] += dxy[i1][j1]*dxy[i1][j1];
           if( dxyflg == 0 ) {
               if( negflg == 1 ) distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
               if( negflg == 0 && dxy[i1][j1] >= 0. ) distw[i1][j1] = distw[j1][i1] = dxy[i1][j1];
               if( negflg == 0 && dxy[i1][j1] < 0. ) distw[i1][j1] = distw[j1][i1] = 0.;
	     }
           if( dxyflg == 1 ){
              if( negflg == 1 )  distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
              if( negflg == 0 && dxy[j1][i1] >= 0. )  distw[i1][j1] = distw[j1][i1] = dxy[j1][i1];
              if( negflg == 0 && dxy[j1][i1] < 0. )  distw[i1][j1] = distw[j1][i1] = 0.;
	    }
	 }
    }

  }
/*  printf("end of dxy\n"); fflush(stdout); */

 

return(0);
}

caldis(cnch,s1,s2,fl,fpo,dw0,dop,nid,nts,ntv,nasite,gammaa)
int cnch[4][4],s1,s2,dop,nid,nts,ntv,nasite;
char **fl/*[MAXOTU][20]*/;
FILE *fpo;
double *dw0,gammaa;
{
int rn,i,j,k;
double dda[2],dq;



/*  if( nts + ntv == 0  ) return(-2); */
  switch(dop){
   case 0:  
            rn=jcdis(&dda[0],nasite,nts+ntv);
/*            printf("s1=%d s2=%d %d %d %f\n",s1,s2,nasite,nts+ntv,dda[0]); */
            if( rn != 0 ) return(-1);
            *dw0 = dda[0];
            break;
   case 1:   rn=k2pdis(&dda[0],nasite,nts,ntv);
             if( rn != 0 ) return(-1);
             *dw0 = dda[0];
              break;
   case 2 :   rn=tndis(&dda[0],cnch,nid+nts+ntv,nts+ntv);
             if( rn != 0 ) return(-1);
             *dw0 = dda[0];
              break;
   case 3 :   rn=tm3dis(&dda[0],cnch,nid+nts+ntv,nts,ntv);
             if( rn != 0 ) return(-1);
             *dw0 = dda[0];
              break;
   case 4 :   
             rn=gmadis(&dda[0],nasite,nts,ntv,gammaa);
/*             printf("gamma %f %f\n",gammaa,dda[0]); */
             if( rn != 0 ) return(-1);
             *dw0 = dda[0];
             break;
   case 12 : *dw0 = ntv;
             *dw0 /= nasite;
             break;

   case 13 : dq = ntv;
             dq /= nasite;
             if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
             *dw0 = -0.25*log(1.0-2.0*dq);
             break;

   case 14 : dq = ntv;
             dq /= nasite;
             if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
             *dw0 = pow(1.0-2.0*dq,-1.0/gammaa)-1.0;
             *dw0 *= 0.25*gammaa;
             break;



   }

  return(0);
}
caldpro(nseq,a,fl,nasite,rsite,dw0,fpo)
FILE *fpo;
char **a/*[MAXSITE][MAXOTU]*/,**fl/*[MAXOTU][MAXNM]*/;
int nasite, *rsite;
double *dw0/*[MAXOTU][MAXOTU]*/;
{
int rn,i,j,k,l,l1,cw,b1,b2,nts,ntv,nid,ndf;


  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
        ndf=0;
        nid=0;
         for(k=0; k<nasite ; k++){
            b1= a[rsite[k]][i];
            b2= a[rsite[k]][j];
            if( b1 !=  b2  ) ndf++;
            if( b1 ==  b2  ) nid++;

        }
        if( nid+ndf != nasite ) return(-10);
        *dw0 = nid;
        *dw0/= nasite;
        *dw0 = -log((*dw0));
/*        printf("%d-%d nid=%d nasite=%d  %f\n",i,j,nid,nasite,dist[i][j]); */
      }

  }
        
return(0);
}


cpart(nseq,part,partb,npart,pb,npw,bw,pw1,pw2)
int nseq, *npart;
int *pb,*npw,*bw;
char *pw1,*pw2;
char **part/*[MAXOTU-3][MAXOTU]*/,**partb/*[MAXOTU-3][MAXOTU]*/;
{
int i,j,k,np,ncf1,ncf2,nb;

np=nseq-3;
/*
printf("part\n");
for(i=0; i<np ; i++){
  for(j=0; j<nseq ; j++) printf(" %d",part[i][j]);
  printf("\n");
}
printf("partb\n");
for(i=0; i<np ; i++){
  for(j=0; j<nseq ; j++) printf(" %d",partb[i][j]);
  printf("\n");
}
*/
for(i=0; i<np ; i++) bw[i]=i;
nb = np;
for(i=0; i<np ; i++){
  for(j=0; j<nseq ; j++){
     pw1[j]=part[i][j];
     switch(part[i][j]){
       case 0 : pw2[j]=1;
                break;
       case 1 : pw2[j]=0;
                break;
       }
   }
       for(j=0; j<nb ; j++){
           ncf1=0;
           ncf2=0;
          for(k=0; k<nseq ; k++){
             if( pw1[k] != partb[bw[j]][k] ) {
                ncf1=1;
                break;
	      }
           }
          if( ncf1 == 0 ) {
             npart[i]++;
             for(k=j; k<nb-1 ; k++) bw[k]=bw[k+1];
             nb--;
             break;
	   }
          for(k=0; k<nseq ; k++){
             if( pw2[k] != partb[bw[j]][k] ) {
                ncf2=1;
                break;
	      }
           }
        
          if( ncf2 == 0 ) {
             npart[i]++;
             for(k=j; k<nb-1 ; k++) bw[k]=bw[k+1];
             nb--;
             break;
	   }
	 }
}
/*
printf("pb:");
for(i=0; i<np ; i++) printf(" %d",pb[i]);
printf("\n");
printf("npart:");
for(i=0; i<np ; i++) printf(" %d",npart[i]);
printf("\n");
*/
return(0);
}
   

delchk(a,nseq0,nsite,npsite,nasite,psite,asite,cdnpos,sitef)
int nseq0,nsite,*npsite,*nasite,*psite,*asite,*cdnpos,*sitef;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,j,k,flg,iw,pol,del,nbs;
  (*npsite) =0;
  (*nasite) =0;
  for(i=0; i<nsite ; i++){
       sitef[i]=0;
       del=0;
       pol=0;
       if( cdnpos[i%3] == 0 ) continue;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
/*          if( dflg == 1 ) printf("a[%d][%d]=%c %x\n",i,j,a[i][j],a[i][j]); */
          if( a[i][j] == '.' ) {
              a[i][j] = a[i][0];
	    }else{
              for(k=0; k<8 ; k++){
                if( a[i][j] == base[k] ) {
                 a[i][j]=k; 
                 flg=1;
                 break;
               }
              }
             if( flg == 0 ){
               printf("seq %d site %d  invalid base %c %x\n",j+1,i+1,a[i][j],a[i][j]);
               exit(1);
	      }
	    }
           if( a[i][j] > 3 ){
                  del=1;   
                  sitef[i]=1;
                  break;
		}
              if( a[i][j] != a[i][0] ) {
                  pol=1;
                  sitef[i]=2;
		}


	}
    
        if( del != 0  ) continue;
        asite[(*nasite)]=i;
        (*nasite)++;
        if( pol == 1 ){
             psite[(*npsite)]=i;
             (*npsite)++;
	   }
     }
    return(0);
}



delchka(a,nseq0,nsite,npsite,nasite,asite,psite,sitef)
int nseq0,nsite,*npsite,*nasite,*asite,*psite,*sitef;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,j,k,flg,iw,pol,del,nbs;
  (*npsite) =0;
  (*nasite) =0;
  for(i=0; i<nsite ; i++){
       del=0;
       pol=0;
       sitef[i]=0;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
/*          if( dflg == 1 ) printf("a[%d][%d]=%c %x\n",i,j,a[i][j],a[i][j]); */
          if( a[i][j] == '.' ) {
             a[i][j] = a[i][0];
	   }else{
            for(k=0; k<23 ; k++){
              if( a[i][j] == amn[k] ) {
                 a[i][j]=k; 
      
                flg=1;
                 break;
           
             }
            }
            if( flg == 0 ){
               printf("seq %d site %d  invalid amn %c %x\n",j+1,i+1,a[i][j],a[i][j]);
               exit(1);
	     }
	  }
           if( a[i][j] >=20 ){
                  del=1;   
                  break;
		}
              if( a[i][j] != a[i][0] ) pol=1;


	}
    
        if( del != 0  ){
         sitef[i]=1;
         continue;
       }
        asite[*nasite]=i;
        (*nasite)++;
        if( pol == 1 ){
             sitef[i]=2;
             psite[(*npsite)]=i;
             (*npsite)++;
	   }
     }
    return(0);
}





/* RAND_MAX is a machine dependent constant, equal to the maximum value
 * random() can return (probably (2^31)-1 = 017777777777 octal).
 */
/* Get an integer to use as a seed for the random number generator */
int getseed()
{
  /****************************************************************
   getpid() returns an integer identifying the current process.  I
   am using this as a random number seed.
   ****************************************************************/
  int getpid();
  int seed;

  seed = getpid();
/*  fprintf(stdout,"getseed(): seed=%d\n", seed); */
  return(seed);
}

checkpop(fp,npop,maxpopname,nseq)
FILE *fp;
int *npop, *maxpopname,nseq;
{
int i,n,cw,ns,nw,rn,n1,n2;
char b[1000],bw[1000],bw1[1000];

  *maxpopname = 0;
  clearzero(b,1000);
  clearzero(bw,1000);

/*  printf("checkpop b:%s\n",b); fflush(stdout); */
  for( ; ; ){
    ns=0;
     n=0;
    for(i=0;  ; i++){
       cw = fgetc(fp);
       b[i] = cw;
       n++;
       if( cw != ' ' && cw != '\t' && cw != '\n') ns++;
       if( cw == '\n' ) break;
     }
     if( ns > 0 ) break;
  }
  
/*  printf("first b:%s\n",b); fflush(stdout); */
  sscanf(b," %d  %s\n",npop,bw);
  if( strcmp(bw,"populations") != 0 ) {
    printf("invalid format in the first line\n");
  }

  n=0;
  for( ; ; ){
    rn = rdline(fp,b,&ns);
    if( ns == 0 ) continue;
    clearzero(bw,1000);
    sscanf(b,"%d %s %d %d",&nw,bw,&n1,&n2);
    if( strlen(bw) > *maxpopname ) *maxpopname = strlen(bw);
    if( n1 <= 0 || n1 > nseq ) {
       printf("invalid sequence number in population %s %d\n",bw,n1);
       exit(1);
     }
    if( n2 <= 0 || n2 > nseq ) {
       printf("invalid sequence number in population %s %d\n",bw,n2);
       exit(1);
     }
    n++;
    if( n == *npop ) break;
    if( rn == -1 ) {
       printf("Number of populations specified is inconsistent\n",n,*npop);
       exit(1);
     }
  }
  return(0);
}

redpop(fp,npop,popname,popseq,nseq)
FILE *fp;
int npop, **popseq,nseq;
char **popname;
{
int i,n,cw,ns,nw,rn,n1,n2;
char b[1000],bw[1000],bw1[1000];

/*  printf("redpop start\n"); fflush(stdout); */
  clearzero(b,1000);
  clearzero(bw,1000);
  clearzero(bw1,1000);
/*   printf("redpop start1\n"); fflush(stdout); */
  for( ; ; ){
    n=0;ns=0;
    for(i=0;  ; i++){
       cw = fgetc(fp);
       b[i] = cw;
       n++;
       if( cw != ' ' && cw != '\t' && cw != '\n' ) ns++;
       if( cw == '\n' ) break;
     }
     if( ns > 0 ) break;
  }
  
  sscanf(b," %d  %s\n",&n1,bw);
  if( strcmp(bw,"populations") != 0 ) {
    printf("invalid format in the first line\n");
  }
  if( n1 != npop ){
    printf("population number inconsistent %d %d\n",n1,npop);
    exit(1);
  }

/*  printf("redpop first line\n"); fflush(stdout); */
  n=0;
  for( ; ; ){
    rn = rdline(fp,b,&ns);
    if( ns == 0 ) continue;
    clearzero(bw,1000);
    sscanf(b,"%d %s %d %d",&nw,bw,&n1,&n2);
/*    printf("nw=%d bw=%s n1=%d n2=%d\n",nw,bw,n1,n2); fflush(stdout); */
    strcpy(popname[n],bw);
    if( n1 <= 0 || n1 > nseq ) {
       printf("invalid sequence number in population %s %d\n",bw,n1);
       exit(1);
     }
    if( n2 <= 0 || n2 > nseq ) {
       printf("invalid sequence number in population %s %d\n",bw,n2);
       exit(1);
     }
     if( n2 - n1 <= 0 ){
        printf("from sequence number is bigger than to sequence number %d %d\n",n1,n2);
       exit(1);
      }
     popseq[n][0] = n1;
     popseq[n][1] = n2;
     popseq[n][2] = n2-n1+1;
     n++;
    if( n == npop ) break;
    if( rn == -1 ) {
       printf("Number of populations specified is inconsistent\n",n,npop);
       exit(1);
     }
  }
  return(0);
}




  
  




clearzero(b,n)
char *b;
int n;
{
int i;

 for(i=0; i<n; i++) b[i]=0;
 return(0);
}
rdline(fp,b,n)
FILE *fp;
char *b;
int *n;
{
int i,cw;

 *n = 0;

  clearzero(b,1000);
  
  for(i=0 ; ;i++ ){
    cw = fgetc(fp);
    if( cw == EOF ) return(-1);
    if( cw != ' ' && cw != '\t' && cw != '\n') (*n)++;
    b[i] = cw;
    if( cw == '\n' ) break;
  }
  return(0);
}

#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349
/* generate uniform random number >= 0 && < 1 */
/* if you want generate random number from 0 to n-1
 *  multiply by n
 *  set *idum by any negative value. The sequence is reset.
 */
float ran1(idum)
int *idum;
{
static long ix1,ix2,ix3;
static float r[98];
float temp;
static int iff=0;
int j;

if( *idum < 0 || iff == 0 ){
   iff = 1;
   ix1 = (IC1 - (*idum)) % M1;
   ix1 = (IA1*ix1+IC1) % M1;
   ix2 = ix1 % M2;
   ix1 = (IA1*ix1+IC1) % M1;
   ix3 = ix1 % M3;
   for(j=1 ; j<97 ; j++){
     ix1 =(IA1*ix1+IC1) % M1;
     ix2 =(IA2*ix2+IC2) % M2;
     r[j] =(ix1+ix2*RM2)*RM1;
   }
   *idum = 1;
 }

 ix1 = (IA1*ix1+IC1) % M1;
 ix2 = (IA2*ix2+IC2) % M2;
 ix3 = (IA3*ix3+IC3) % M3;
 j = 1 + ((97*ix3)/M3);
 if( j > 97 || j < 1 ) {
   printf("ran1(): j = %d \n");
   exit(1);
 }
 temp = r[j];
 r[j]=(ix1 + ix2*RM2)*RM1;
 return(temp);
}

  





main(argc,argv)
int argc;
char **argv;
{
FILE *fpo=stdout,*fpi,*fpe=stderr,*fpb=stdin,*fpp=stdin;
int i,j,k,nc,nc1,nc2,opt,fin,ifc,sc,rn,nln,trn,n,flg,colon,numf,nlm,ndat,nng[9];
int ipc,maxpopname;
int nseq,**node/*[MAXOTU-2][3]*/,**nodeb/*[MAXOTU-2][3]*/,nsite,seed,ncor,emp,tief,ntie,seed1;
float fw;
double accu;
char **popnaname;
int lun,nuns,*npart/*[MAXOTU-3]*/;
double **branch0/*[MAXOTU][3]*/,**branchb/*[MAXOTU][3]*/,gamma=1.0,**distp;
char **fl/*[MAXOTU][MAXNM]*/,**a/*[MAXSITE][MAXOTU]*/,br1[10],br2[10],b[1500];
char **part/*[MAXOTU-3][MAXOTU]*/,**partb/*[MAXOTU-3][MAXOTU]*/;
Nodc **nodes/*[MAXOTU-2]*/;
char **popname;
int nbn,ndel,**bri/*[MAXOTU-3][2]*/,**brib/*[MAXOTU-3][2]*/,dop,nasite,nboot,*asite/*[MAXSITE]*/,*psite/*[MAXSITE]*/,npsite,*sitef/*[MAXSITE]*/,maxnm;
int bootflg,dxyflg,negflg;
double *dx, *dxs,*dxss,**dxy,**dxyb,**dxys,**das,*dxb,dxall,dxas,dxass,dxallw;
int **popseq;
int *rsite/*[MAXSITE]*/,nw[3],nb,n1,n2,ninap=0,cdnpos[3],iw,npop,nseqp;
static char *distop[18]={"JC distance","K2P distance","Tajima Nei distance","Tamura distance","Gamma distance","amino Poisson","amino p-distance","amino Gamma","Tamura Nei","Tamura Nei Gamma","p-distance","p-distance with gap","V(proportion)","V K2P","V K2P gamma","V Hasegawa","V Hasegawa gamma","number of difference"};
/* njt */
int *otu,**spair,*sw,*pb,*npw,*bw;
double *st,*dcm,*rij;
char *ncn,*rlo,*rli,*chf,*pw1,*pw2;
int *ivector(),**imatrix();
char *cvector(),**cmatrix();
double *dvector(),**dmatrix();
Nodc **nvector();
float ran1();

dop=0;

/* negflg = 0  -- negative distance is set to zero */
/* negflg = 1  -- negative distance is used */ 
negflg = 0;
 cdnpos[0]=cdnpos[1]=cdnpos[2]=1;
   seed=getseed();
   dop=0;
   nboot=0;
   dxyflg = 0;
   ifc = 0;
   ipc = 0;
   accu=ACU;
   if( argc == 1 ){
     printf("sendbs sequencefile -p[population file] -d[distace option]  -b[bootstrap number] -o[output file] -s[seed] -dxy -neg -g[gamma parameter]\n");
     printf("distance option\n");
     for(i=0; i<17 ; i++){
       printf("%d    %s\n",i,distop[i]);
     }
     exit(1);
   }
  
   for(i=1; i<argc ; i++){
     if( argv[i][0] == '-' ){
      if( strcmp(argv[i]+1,"dxy") == 0 ){
       dxyflg=1;
       continue;
     }
      if( strcmp(argv[i]+1,"neg") == 0 ){
       negflg=1;
       continue;
     }
      switch( argv[i][1]){
       case 'o' : if((fpo=fopen(argv[i]+2,"w")) == NULL ) {
                    fprintf(fpe,"Can't open output-file:%s\n",argv[i]+2);
                    exit(1);
                  }
                  break;
       case 'p' : if((fpp=fopen(argv[i]+2,"r")) == NULL ) {
                    fprintf(fpe,"Can't open output-file:%s\n",argv[i]+2);
                    exit(1);
                  }
                  ipc=i;
                  break;
       case 'd' :  sscanf(argv[i]+2,"%d",&dop);
                   if( dop > 16 || dop < 0 ){
                      fprintf(fpe,"invalid option\n",opt);
                      exit(1);
                   }
                  break;


       case 'c' :  cdnpos[0]=cdnpos[1]=cdnpos[2]=0;
                   if( argv[i][2] >= '0' && argv[i][2] <= '3' ){
                     sscanf(argv[i]+2,"%d",&iw);
                     cdnpos[iw-1]=1;
                   }
                   for(j=i+1 ; j<argc ; j++){
                     if( argv[j][0] == '-' ) break;
                     if( argv[j][0] >= '0' && argv[j][0] <= '3' ){
                     sscanf(argv[j],"%d",&iw);
                     cdnpos[iw-1]=1;
                     i++;
                   }
		   }
                  break;

       case 'g' :  sscanf(argv[i]+2,"%f",&fw);
                   if( fw < 0.0 ){
                      fprintf(fpe,"invalid option gamma=%f\n",fw);
                      exit(1);
                   }
                  gamma=fw;
                  break;
       case 'b' :  sscanf(argv[i]+2,"%d",&nboot);
                   break;
       case 's' :  sscanf(argv[i]+2,"%d",&seed);
                   break;
       case 'u' :  if(argv[i][2] == 0 ){
                     dflg=1;
                     break;
                   }
                   sscanf(argv[i]+2,"%d",&dflg);
                   break;
       default :  fprintf(fpe,"invalid argument",argv[i]);
                  exit(1);
      }
     }else{
      if((fpi=fopen(argv[i],"r")) == NULL ){
                fprintf(fpe,"Can't open input-file:%s\n",argv[i]);
                exit(1);
      }
      fin=i;
      ifc++;


     }
   }

/*  printf("end of arguments\n");  */

  if( ifc == 0 ){
      fprintf(fpe,"no input-file\n");
      exit(1);
   }
  if( ipc == 0 ){
      fprintf(fpe,"no population-file\n");
      exit(1);
   }
  ifc=0;
  sc=0;
 nseq=0;
 nln=0;
 npop=0;

checkfl(fpi,&nseq,&nsite,&maxnm);
fclose(fpi);
if( (fpi= fopen(argv[fin],"r")) == NULL ){
  fprintf(fpo,"Can't open sequence file %s\n",argv[fin]);
  exit(1);
}
/* printf("maxnm=%d\n",maxnm);  fflush(stdout);*/

/*ndis = imatrix(nseq,nseq); */
/*dist = dmatrix(nseq,nseq); */
fl = cmatrix(nseq,maxnm+1);
a = cmatrix(nsite,nseq);
asite = ivector(nsite);
psite = ivector(nsite);
sitef = ivector(nsite);
rsite = ivector(nsite);
for(i=0; i<nseq ; i++){
 for(j=0; j<maxnm+1 ; j++) fl[i][j]=0;
}




rdseq(fpi,nseq,nsite,a,fl,maxnm);
fclose(fpi);
/* fprintf(fpo,"before checkpop\n"); fflush(stdout); */

checkpop(fpp,&npop,&maxpopname,nseq);
fclose(fpp);
/* fprintf(fpo,"%d populations maxpopnam=%d\n",npop,maxpopname);
   fflush(stdout); 
*/
popname = cmatrix(npop,maxpopname+1);
popseq = imatrix(npop,3);

for(i=0; i<npop ; i++){
  for(j=0; j<maxpopname+1; j++) popname[i][j] = 0;
  for(j=0; j<3 ; j++ ) popseq[i][j] = 0;
}


if( (fpp= fopen(argv[ipc]+2,"r")) == NULL ){
  fprintf(fpo,"Can't open poplation file %s\n",argv[ipc]+2);
  exit(1);
}
/*  fprintf(fpo,"before redpop\n"); fflush(stdout); */
redpop(fpp,npop,popname,popseq,nseq);
fclose(fpp);
/*
  fprintf(fpo,"%d populations\n",npop);
  for(i=0; i<npop ; i++) {
    fprintf(fpo,"%2d %s %3d %3d (%3d)\n",i+1,popname[i],popseq[i][0],popseq[i][1],popseq[i][2]);
  }
*/
  fflush(stdout);
/* population distances 
   dxy[i][j] i<j : da = dxy -(dx+dy)/2 
   dxy[j][i]     : dxy
   dxys[i][j]    : dxys   sum
   dxys[j][i]    : dxyss  square sum
   das[i][j]     : das   sum of da
   das[j][i]     : dass  square sum
*/

   
dx = dvector(npop);
dxs = dvector(npop);
dxss = dvector(npop);
dxb = dvector(npop);
dxy =  dmatrix(npop,npop);
dxyb =  dmatrix(npop,npop);
dxys =  dmatrix(npop,npop);
das =  dmatrix(npop,npop);
distp =  dmatrix(npop,npop);

/* nj tree memory allocation */
node = imatrix(npop-2,3);
nodeb = imatrix(npop-2,3);
npart = ivector(npop-3);
branch0 = dmatrix(npop,3);
branchb = dmatrix(npop,3);
for(i=0; i<npop ; i++){
  for(j=0; j<3 ; j++) branch0[i][j]=branchb[i][j]=0.;
}
part = cmatrix(npop-3,npop);
partb = cmatrix(npop-3,npop);
nodes = nvector(npop-2);
bri = imatrix(npop-3,2);
brib = imatrix(npop-3,2);
otu = ivector(npop);
spair = imatrix(npop*(npop-1)/2,2);
sw = ivector(npop*(npop-1)/2);
st = dvector(npop*(npop-1)/2);
dcm = dvector(npop);
rij = dvector(npop);
ncn = cvector(npop-2);
rlo = cvector(npop);
rli = cvector(npop-2);
chf = cvector(npop-2);
pb = ivector(npop-3);
npw = ivector(npop-3);
bw = ivector(npop-3);
pw1 = cvector(npop);
pw2 = cvector(npop);




ndel=0;
  if( dop >=5 && dop <= 7 ) delchka(a,nseq,nsite,&npsite,&nasite,asite,psite,sitef);
  else delchk(a,nseq,nsite,&npsite,&nasite,psite,asite,cdnpos,sitef);

  if( nboot > 0 ) fprintf(fpo,"   %d otus    %d bootstraping\n",npop,nboot);
  if( nboot == 0 ) fprintf(fpo,"   %d otus\n",npop); fflush(fpo);

  /*   fprintf(fpo,"   %d otus\n",npop); fflush(fpo);*/
/*
   for(i=0; i<nseq ; i++ ){
     printf("%s ",fl[i]);
     for(j=0; j<nasite ; j++){
       printf("%c",base[a[asite[j]][i]]);
     }
     printf("\n");
   }
*/
   for(i=0; i<npop ; i++){
     fprintf(fpo,"%d %s\n",i+1,popname[i]);
    }
    fflush(fpo);
/*     srandom(seed); */
     seed1 = -seed;
     ran1(&seed1);
     bootflg = 0;
     for(i=0; i< npop-3 ; i++) npart[i]=0;
/*        printf("check nseq=%d\n",nseq); fflush(stdout); */
        dxall = 0.;
        rn=caldist(nseq,npop,popseq,&dxall,dx,dxy,dxs,dxss,dxys,das,distp,&nseqp,a,fl,nasite,asite,npsite,psite,dop,fpo,gamma,bootflg,dxyflg,negflg);
/*       printf("caldist end\n"); fflush(stdout); */
           if( rn == -1 ) {
           printf("distance was inapplicable\n");
           exit(1);
         }
       dxall /= nseqp;
/*       printf("dxall=%f nseqp=%d\n",dxall,nseqp); fflush(stdout);*/
       nseqp=0;
       dxas = dxass = 0.;


      for(i=0; i<npop-1 ; i++){
       for(j=i+1; j< npop ; j++){
         if( dxyflg == 0 ){
            if( negflg == 1){
               distp[i][j] = dxy[i][j];
               distp[j][i] = dxy[i][j];
	     }
            if( negflg == 0){
              if( dxy[i][j] >= 0.){
                 distp[i][j] = dxy[i][j];
                 distp[j][i] = dxy[i][j];
	      }else{
               distp[i][j] = 0.;
               distp[j][i] = 0.;
	     }
	    }
	  }else{
            if( negflg == 0 ){
               distp[i][j] = dxy[j][i];
               distp[j][i] = dxy[j][i];
	     }else{
               if( dxy[j][i] >= 0. ){
                  distp[i][j] = dxy[j][i];
                  distp[j][i] = dxy[j][i];
		}else{
                  distp[i][j] = 0.;
                  distp[j][i] = 0.;
		}

	     }
	  }
       }
     }
    if( npop > 2 ){
      njt(npop,distp,node,branch0,otu,spair,sw,st,dcm,rij); 
      /*      printf("njt end\n"); fflush(stdout);  */

      njtndp(npop,node,nodes,ncn);
      parti(npop,nodes,part,bri,rlo,rli,chf);
    }
      for(i=0; i< npop ; i++){
       dxs[i]=dxss[i]=0.;
      }
      for(i=0; i<npop-1 ; i++){
       for(j=i+1 ; j<npop ; j++){
         dxys[i][j] = dxys[j][i] = 0.;
         das[i][j] = das[j][i] = 0.;
       }
     }
      bootflg=1;
      for(nbn=0; nbn < nboot ; ){
	/*         printf("nbn=%d\n",nbn); fflush(stdout);*/
         ressite(nasite,asite,rsite,psite,&npsite,sitef,&seed1);
         dxallw = 0.;
         rn=caldist(nseq,npop,popseq,&dxallw,dxb,dxyb,dxs,dxss,dxys,das,distp,&nseqp,a,fl,nasite,rsite,npsite,psite,dop,fpo,gamma,bootflg,dxyflg,negflg);
         if( rn != 0 ) {
           ninap++;
           continue;
         }
/*         printf("nbn=%d dxallw=%f\n",nbn,dxallw);*/
         dxallw /= nseqp;
         dxas += dxallw;
         dxass += dxallw*dxallw;
        if( npop > 3 ){
           njr(npop,distp,nodeb,branchb,otu,spair,sw,st,dcm,rij,&seed1,accu); 
	   /*
           for(i=0; i<npop-3; i++){
           printf(" %d %d %d %f %f %f\n",nodeb[i][0],nodeb[i][1],nodeb[i][2],branchb[i][0],branchb[i][1],branchb[i][2]);
	   }
           printf("\n");
	   */
           njtndp(npop,nodeb,nodes,ncn);
           parti(npop,nodes,partb,brib,rlo,rli,chf);
           cpart(npop,part,partb,npart,pb,npw,bw,pw1,pw2);
	   /*           for(i=0; i<npop-3 ; i++) printf("%d ",npart[i]);
	         printf("\n"); fflush(stdout);*/
	}
         nbn++;
       }
      if( npop > 2){
        for(i=0; i<npop-2 ; i++){
         nb=2;
       if( i == npop-3 ) nb=3;
       for(j=0; j<nb ; j++){
          if( node[i][j] <= npop ) nw[j]= nboot;
          if( node[i][j]  > npop ) {
              n1=i+1;
              n2=node[i][j]-npop;
              if( n1 > n2 ){
                  nc = n1;
                  n1=n2;
                  n2=nc;
		}
               for(k=0; k<npop-3 ; k++){
                 if( bri[k][0] == n1 && bri[k][1] == n2 ) {
                    nw[j] = npart[k];
                    break;
		  }
	       }
	    }

              if( nboot > 0 ) fprintf(fpo,"%3d and %3d        %f    %6d\n",npop+i+1,node[i][j],branch0[i][j],nw[j]);
              if( nboot == 0 ) fprintf(fpo,"%3d and %3d        %f\n",npop+i+1,node[i][j],branch0[i][j]);
	      /*              fprintf(fpo,"%3d and %3d        %f\n",npop+i+1,node[i][j],branch0[i][j]);*/
	}
       }
      }  

fprintf(fpo,"\n");
fprintf(fpo,"%s was used\n",distop[dop]);
if( dop == 7 || dop == 9 || dop == 4 || dop == 14 || dop == 16 ) fprintf(fpo,"gamma = %f\n",gamma);
fprintf(fpo,"\n");
fprintf(fpo,"Number of nucleotide sites compared %d (nsite=%d)\n",nasite,nsite);
fprintf(fpo,"seed=%d ninap=%d\n",seed,ninap);
if( cdnpos[0]+cdnpos[1]+cdnpos[2] != 3 ){
     fprintf(fpo,"codon position:");
     for(i=0; i<3 ; i++){
       if( cdnpos[i] == 1 ) fprintf(fpo," %d",i+1);
     }
     fprintf(fpo,"\n");
   }
if( dxyflg == 1 ) fprintf(fpo,"dxy was used to construct an NJ tree.\n");
fprintf(fpo,"\n\n");
fprintf(fpo,"Within populations\n");
if( nboot > 0 ) fprintf(fpo,"population from  to (#  )   diversity     se\n");
if( nboot == 0 ) fprintf(fpo,"population from  to (#  )   diversity\n");
for(i=0; i<npop ; i++){
  fprintf(fpo,"%2d %s",i+1,popname[i]);
  n = strlen(popname[i]);
  for(j=0; j< maxpopname-n; j++) fprintf(fpo," ");
  fprintf(fpo,"    %3d %3d (%3d)",popseq[i][0],popseq[i][1],popseq[i][2]);
  if( nboot > 0 ){
    dxs[i] /= nboot;
    dxss[i] /= nboot;
    dxss[i] -= dxs[i]*dxs[i];
    dxss[i] /= nboot-1;  
    dxss[i] *= nboot;  
  }
  if( nboot > 0 ) fprintf(fpo,"  %10.8f  %10.8f\n",dx[i],sqrt(dxss[i]));
  if( nboot == 0 ) fprintf(fpo,"  %10.8f\n",dx[i]);
}
fprintf(fpo,"\n");
fprintf(fpo,"Between populations\n");
if( nboot > 0 ) fprintf(fpo,"populations     dxy        se            da          se\n");
if( nboot == 0 ) fprintf(fpo,"populations     dxy        da\n");
for(i=0; i<npop-1 ; i++){
 for(j=i+1; j<npop ; j++){
  if( nboot > 0 ){
    dxys[i][j] /= nboot;
    dxys[j][i] /= nboot;
    dxys[j][i] -= dxys[i][j]*dxys[i][j];
    dxys[j][i] /= nboot-1;
    dxys[j][i] *= nboot;
    das[i][j] /= nboot;
    das[j][i] /= nboot;
    das[j][i] -= das[i][j]*das[i][j];
    das[j][i] /= nboot-1;
    das[j][i] *= nboot;
    fprintf(fpo,"   %2d %2d    %10.8f  %10.8f    %10.8f  %10.8f\n",i+1,j+1,dxy[j][i],sqrt(dxys[j][i]),dxy[i][j],sqrt(das[j][i])); 
  }
  if( nboot == 0 ) fprintf(fpo,"   %2d %2d    %10.8f  %10.8f\n",i+1,j+1,dxy[j][i],dxy[i][j]); 
  
}
}

fprintf(fpo,"\n\n");
fprintf(fpo,"Diversity in whole population\n");
if( nboot > 0 ){
  dxass /= nboot;
  dxas /= nboot;
  dxass -= dxas*dxas;
  dxass /= nboot-1;
  dxass *= nboot;
  fprintf(fpo,"Diversity = %10.8f s.e. %10.8f\n",dxall,sqrt(dxass));
}
if( nboot == 0 ) fprintf(fpo,"Diversity = %10.8f\n",dxall);
if( nboot > 0 ) fprintf(fpo,"%d bootstrapping\n",nboot);
if( negflg == 0 ) fprintf(fpo,"Negative values of average distances between populations were set to zero\nwhen the NJ tree was constructed.\n");
if( negflg == 1 ) fprintf(fpo,"Negative values of average distances between populations were allowed\nwhen the NJ tree was constructed.\n");


free_dvector(dx,npop);
free_dvector(dxs,npop);
free_dvector(dxss,npop);
free_dvector(dxb,npop);
free_dmatrix(dxy,npop,npop);
free_dmatrix(dxyb,npop,npop);
free_dmatrix(dxys,npop,npop);
free_dmatrix(das,npop,npop);
free_dmatrix(distp,npop,npop);

free_cmatrix(popname,npop,maxpopname+1);
free_imatrix(popseq,npop,3);
free_imatrix(node,npop-2,3);
free_imatrix(nodeb,npop-2,3);
free_ivector(npart,npop-3);
free_dmatrix(branch0,npop,3);
free_dmatrix(branchb,npop,3);
free_cmatrix(fl,nseq,maxnm+1);
free_cmatrix(a,nsite,nseq);
free_cmatrix(part,npop-3,npop);
free_cmatrix(partb,npop-3,npop);
free_nvector(nodes,npop-2);
free_imatrix(bri,npop-3,2);
free_imatrix(brib,npop-3,2);

free_ivector(otu,npop);
free_imatrix(spair,npop*(npop-1)/2,2);
free_ivector(sw,npop*(npop-1)/2);
free_dvector(st,npop*(npop-1)/2);
free_dvector(dcm,npop);
free_dvector(rij,npop);
free_cvector(ncn,npop-2);
free_cvector(rlo,npop);
free_cvector(rli,npop-2);
free_cvector(chf,npop-2);
free_ivector(pb,npop-3);
free_ivector(npw,npop-3);
free_ivector(bw,npop-3);
free_cvector(pw1,npop);
free_cvector(pw2,npop);

free_ivector(asite,nsite);
free_ivector(psite,nsite);
free_ivector(sitef,nsite);
free_ivector(rsite,nsite);
    exit(0);
  }


